@ECHO OFF >NUL
SETLOCAL EnableExtensions

if exist QDFilelist.txt del QDFilelist.txt

:: create a UNICODE file with Byte Order Mark using `wmic` 
chcp 852 >NUL
>QDFilelist.txt wmic os get localdatetime

:: store a line with BOM to a variable
:: although FINDSTR does not support UTF-16 files
:: it will read first three bytes at least
for /F "delims=" %%G in ('
    findstr "^" QDFilelist.txt
  ') do set "UTF8BOM=%%G"

:: write BOM only* to a file (* echo writes hexadecimal value FFFE0D0A)
:: the `<NUL set /p =text` trick does not work: chokes down leading `FF`  
>QDFilelist.txt echo(%UTF8BOM:~0,2%

chcp 65001 >NUL

:: add result of `dir /B /O:N` in Unicode 
cmd /U /C dir /B %1*.dim %1*.cub > QDFilelist.txt 

:: check the result: still invalid first line, see output
type QDFilelist.txt
chcp 852 >NUL
if exist %2QDPackage.7z del %2QDPackage.7z
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z QDFilelist.txt 
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1*.rux 
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1*.pro 
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1*.cho 
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1*.qson 
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1*}vues 
.\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1*}subs 

set "tm1s=%~3"
set "lastChar=%tm1s:~-1%"

if %lastChar% == \ (
	if not exist "%tm1s%tm1s.cfg" .\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1tm1s.cfg
	if exist "%tm1s%tm1s.cfg" .\QUBEdocsFiles\7za.exe a %2QDPackage.7z "%tm1s%tm1s.cfg"
)

if not %lastChar% == \ (
	if not exist "%~3\tm1s.cfg" .\QUBEdocsFiles\7za.exe a %2QDPackage.7z %1tm1s.cfg
	if exist "%~3\tm1s.cfg" .\QUBEdocsFiles\7za.exe a %2QDPackage.7z "%~3\tm1s.cfg"
)

if exist %2QDFilelist.txt del %2QDFilelist.txt